
class Card

  SUITS = [:spade, :club, :heart, :diamond]
  ICONS = { spade:"\u2660", club:"\u2663", heart:"\u2665", diamond:"\u2666" }
  VIEW = { 1 => "A", 11 => "J", 12 => "Q", 13 => "K", 14 => "A" }

  def initialize(suit, rank)
    @suit = suit
    @rank = rank
    @view = self.view()
  end

  def suit
    @suit
  end

  def rank
    @rank
  end

  def value(ace=:high)
    val = 
      if @rank == 14 or @rank == 1
        ace == :high ? 11 : 1
      elsif @rank >= 11 and @rank <= 13
        10
      else
        @rank
      end
  end

  def view()
    view = VIEW[@rank]
    view ||= @rank
  end

  def to_s()
    "#{ICONS[@suit]}#{@view}"
  end

end