require_relative "card"

class Deck

  def initialize(shuffle=true)
    @cards =
    (2..14).map do |rank|
      Card::SUITS.map do |suit|
        Card.new(suit, rank)
      end
    end
    @cards = @cards.flatten()
    self.shuffle! if shuffle
  end

  def cards
    @cards
  end

  def shuffle
    @cards.shuffle
  end

  def shuffle!
    @cards.shuffle!
  end

  def to_s
    @cards.map(&:to_s).join(',')
  end

  def draw
    @cards.pop
  end

  def cards_left
    @cards.length
  end

  alias size cards_left
  alias length cards_left
end

