require_relative "deck"

class Player

  def initialize
    @cards = []
  end

  def hit(deck)
    @cards.push(deck.draw)
  end

  def deal(deck)
    2.times { self.hit(deck) }
  end

  def card_sum(ace=:high)
    sum = 0
    @cards.each { |c| sum += c.value(ace) }
    sum
  end

  #returns a best-possible score invariable of aces
  def score
    score = self.card_sum(ace=:high)
    self.send(:aces).times do
      score -= 10
      return score if score <= 21
    end
    return score
  end

  def hit_or_stay?
    if self.card_sum(:high) < 11 or self.card_sum(:low) < 11
      return true
    end
    return false
  end

  def cards
    @cards
  end

  # for debug
  def cards=(new_hand)
    @cards = new_hand
  end

  private

    def aces
      @cards.count { |x| x.value(:low) == 1 }
    end

end

